--
-- best camera mod
-- @author: Flume
-- @date: 05.01.2017
--

print("-----------");
print("Best Player Camera loaded..");
print("@Author: Flume");
print("@Version: 1.0");
print("-----------");

--

flume_PlayerCamera = {};

function flume_PlayerCamera:loadMap(name)
	self.playerCamYBackup = 0.73;
	self.fovAngleBackup = 60;
	self.fovAngle = 60;
end;

function flume_PlayerCamera:mouseEvent(posX, posY, isDown, isUp, button)
	if g_currentMission.controlPlayer and g_gui.currentGui == nil then
		if g_currentMission.player ~= nil then
			if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_RIGHT) then
				self.fovAngle = getFovy(g_currentMission.player.cameraNode);
				
				if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_UP) and self.fovAngle > 2 then
					setFovy(g_currentMission.player.cameraNode, self.fovAngle-2)
				end;
				if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_DOWN) and self.fovAngle < 178 then		
					setFovy(g_currentMission.player.cameraNode, self.fovAngle+2)
				end;	
				if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_MIDDLE) then
					setFovy(g_currentMission.player.cameraNode, self.fovAngleBackup)		
				end;			
			else
				if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_UP) and g_currentMission.player.camY > -0.7 then
					g_currentMission.player.camY = g_currentMission.player.camY-0.4;
				end;
				if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_WHEEL_DOWN) then		
					g_currentMission.player.camY = g_currentMission.player.camY+0.4;
				end;		
				if Input.isMouseButtonPressed(Input.MOUSE_BUTTON_MIDDLE) then
					g_currentMission.player.camY = self.playerCamYBackup;			
				end;
			end;
		end;
	end;
end;

function flume_PlayerCamera:keyEvent(unicode, sym, modifier, isDown)
end;

function flume_PlayerCamera:update(dt)
	if g_currentMission.controlPlayer and g_gui.currentGui == nil then
		g_currentMission:addHelpButtonText(g_i18n:getText("normalSpeed"), InputBinding.normalSpeed);
		g_currentMission:addHelpButtonText(g_i18n:getText("slowSpeed"), InputBinding.slowSpeed);
		g_currentMission:addHelpButtonText(g_i18n:getText("slow2Speed"), InputBinding.slow2Speed);
		g_currentMission:addHelpButtonText(g_i18n:getText("fastSpeed"), InputBinding.fastSpeed);
		
		-- normal speed --
		if InputBinding.isPressed(InputBinding.normalSpeed) then
			g_currentMission.player.walkingSpeed = 0.005;           -- key [0]
		end;
		-- slow speed --
		if InputBinding.isPressed(InputBinding.slowSpeed) then
			g_currentMission.player.walkingSpeed = 0.0006;          -- key [1]
		end;
		-- slow2 speed --
		if InputBinding.isPressed(InputBinding.slow2Speed) then
			g_currentMission.player.walkingSpeed = 0.001;           -- key [2]
		end;
		-- fast speed --
		if InputBinding.isPressed(InputBinding.fastSpeed) then
			g_currentMission.player.walkingSpeed = 0.10;            -- key [3]
		end;
	end;
end;

function flume_PlayerCamera:draw()
end;

function flume_PlayerCamera:deleteMap()
	print("-- Best Player Camera deleted..");
end;

function flume_PlayerCamera:delete()
end;

addModEventListener(flume_PlayerCamera);